Package org.apache.sysds.runtime.compress.colgroup

## Class ASDC

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
    - - org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup
      - - org.apache.sysds.runtime.compress.colgroup.AColGroupValue
        - - org.apache.sysds.runtime.compress.colgroup.AMorphingMMColGroup
          - - org.apache.sysds.runtime.compress.colgroup.ASDC

All Implemented Interfaces:
  `Serializable`, `AOffsetsGroup`

Direct Known Subclasses:
  `ColGroupSDC`, `ColGroupSDCFOR`, `ColGroupSDCSingle`

    public abstract class ASDC
    extends AMorphingMMColGroup
    implements AOffsetsGroup

Column group that sparsely encodes the dictionary values. The idea is that all values is encoded with indexes except the most common one. the most common one can be inferred by not being included in the indexes. This column group is handy in cases where sparse unsafe operations is executed on very sparse columns. Then the zeros would be materialized in the group without any overhead.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

### Method Summary

All Methods Instance Methods Abstract Methods Concrete Methods
`abstract double[]` `getDefaultTuple()`
`int` `getNumRows()`
`AOffset` `getOffsets()`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AMorphingMMColGroup

`extractCommon, getCommon, leftMultByAColGroup, leftMultByMatrixNoPreAgg, tsmmAColGroup`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupValue

`centralMoment, computeColSums, estimateInMemorySize, getCounts, getNumberNonZeros, getNumValues, replace, rexpandCols, toString`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup

`decompressToDenseBlock, decompressToSparseBlock, getDictionary, getExactSizeOnDisk, rightMultByMatrix, write`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, getSum, isEmpty, preAggRows, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`append, appendN, binaryRowOpLeft, binaryRowOpRight, colSum, containsValue, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getCompressionScheme, getCompType, getCost, getIdx, getNumCols, rightMultByMatrix, scalarOperation, shiftColIndices, sliceColumn, sliceColumns, sliceRows, unaryOperation`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### getNumRows

    public int getNumRows()

#### getDefaultTuple

    public abstract double[] getDefaultTuple()

#### getOffsets

    public AOffset getOffsets()

Specified by:
  `getOffsets` in interface `AOffsetsGroup`